![test](https://mygit.th-deg.de/roboct/robo_quality/gitlab-profile/-/raw/main/resources/rq_hardware_450.png?inline=false)

# RoboQualityHardware

Hardware interface for the RoboQuality project.  
If the interface should use the simulation interface in combination with aRTist, this node has to be started on the same pc as the running aRTist instance.  


# Node Architecture

1. All calls of the interface to the simulation software or to the real hardware should run via an instance of the [`hardware_client`](https://mygit.th-deg.de/roboct/robo_quality/rq_hardware/-/blob/main/rq_hardware/hardware_client.py?ref_type=heads#L13) .  
2. The client expects the service defined in the [`base_hardware_service`](https://mygit.th-deg.de/roboct/robo_quality/rq_hardware/-/blob/main/rq_hardware/base_hardware_service.py?ref_type=heads#L11) class. 
3. To implement a new interface to a simulation or a real system, for example, the functionalities of the base hardware class must be implemented and a new node [`entry point`](https://mygit.th-deg.de/roboct/robo_quality/rq_hardware/-/blob/main/setup.py?ref_type=heads#L23) must be created.


# Summary

| Interface | Type | Status | Description | 
| --- | --- | --- | --- |
| `aRTist` | Simulation | &check; | [aRTist API](https://github.com/wittlsn/aRTist-PythonLib/tree/artist_thd_wip) is used as Xray simulation. To simulate reachability a collission mesh must be provided to a node specific topic. Reachability is is only defined as an estimate of whether source or detector are in the collision mesh. Pathfinding is also an estimation of an third party packages |
| `thd_roboct` | Real System | `WIP` | Interfacec to the RoboCT system in Deggendorf. Not yet tested. |
| `echo` | Test System | `WIP` | Echos dummy resposnse for CI node tests. | 

